dnl aclocal.m4 generated automatically by aclocal 1.4

dnl Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
dnl This file is free software; the Free Software Foundation
dnl gives unlimited permission to copy and/or distribute it,
dnl with or without modifications, as long as this notice is preserved.

dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY, to the extent permitted by law; without
dnl even the implied warranty of MERCHANTABILITY or FITNESS FOR A
dnl PARTICULAR PURPOSE.

#
# Enhydra Java Application Server 
# The Initial Developer of the Original Code is Lutris Technologies Inc. 
# Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
# Inc. 
# All Rights Reserved. 
#
# The contents of this file are subject to the Enhydra Public License Version
# 1.0 (the "License"); you may not use this file except in compliance with the
# License. You may obtain a copy of the License at
# http://www.enhydra.org/software/license/epl.html 
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations under the
# License. 
#
# $Id: aclocal.m4,v 1.1 2003/04/14 12:25:56 sinisa Exp $
#

# No special macros for CGI.

# Add --enable-maintainer-mode option to configure.
# From Jim Meyering

# serial 1

AC_DEFUN(AM_MAINTAINER_MODE,
[AC_MSG_CHECKING([whether to enable maintainer-specific portions of Makefiles])
  dnl maintainer-mode is disabled by default
  AC_ARG_ENABLE(maintainer-mode,
[  --enable-maintainer-mode enable make rules and dependencies not useful
                          (and sometimes confusing) to the casual installer],
      USE_MAINTAINER_MODE=$enableval,
      USE_MAINTAINER_MODE=no)
  AC_MSG_RESULT($USE_MAINTAINER_MODE)
  AM_CONDITIONAL(MAINTAINER_MODE, test $USE_MAINTAINER_MODE = yes)
  MAINT=$MAINTAINER_MODE_TRUE
  AC_SUBST(MAINT)dnl
]
)

# Define a conditional.

AC_DEFUN(AM_CONDITIONAL,
[AC_SUBST($1_TRUE)
AC_SUBST($1_FALSE)
if $2; then
  $1_TRUE=
  $1_FALSE='#'
else
  $1_TRUE='#'
  $1_FALSE=
fi])

dnl
dnl  Enhydra Java Application Server 
dnl  The Initial Developer of the Original Code is Lutris Technologies Inc. 
dnl  Portions created by Lutris are Copyright (C) 1997-2000 Lutris
dnl  Technologies Inc. 
dnl  All Rights Reserved. 
dnl
dnl  The contents of this file are subject to the Enhydra Public License
dnl  Version 1.0 (the "License"); you may not use this file except in
dnl  compliance with the License. You may obtain a copy of the License at
dnl  http://www.enhydra.org/software/license/epl.html 
dnl
dnl  Software distributed under the License is distributed on an "AS IS"
dnl  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
dnl  License for the specific language governing rights and limitations
dnl  under the License. 
dnl
dnl  $Id: aclocal.m4,v 1.1 2003/04/14 12:25:56 sinisa Exp $
dnl

dnl
dnl M4 macros and code shared by all configure.in files.  This defines
dnl a macro EDIR_COMMON while inserts the common code.
dnl

AC_DEFUN(EDIR_COMMON, [
    AC_CONFIG_AUX_DIR(../config/scripts/unix)
    AM_INIT_AUTOMAKE(EnhydraDirector,1.0)
    AM_CONFIG_HEADER(config.h:config.h.in)

    dnl XML lib info
    LIBXML_MAJOR_VERSION=2
    LIBXML_MINOR_VERSION=2
    LIBXML_MICRO_VERSION=1
    LIBXML_VERSION=$LIBXML_MAJOR_VERSION.$LIBXML_MINOR_VERSION.$LIBXML_MICRO_VERSION
    LIBXML_VERSION_INFO=`expr $LIBXML_MAJOR_VERSION + $LIBXML_MINOR_VERSION`:$LIBXML_MICRO_VERSION:$LIBXML_MINOR_VERSION
    AC_SUBST(LIBXML_MAJOR_VERSION)
    AC_SUBST(LIBXML_MINOR_VERSION)
    AC_SUBST(LIBXML_MICRO_VERSION)
    AC_SUBST(LIBXML_VERSION)
    AC_SUBST(LIBXML_VERSION_INFO)

    dnl Checks for programs.

    AC_PATH_PROG(TEST,test,$PATH)

    AC_ARG_ENABLE(debugging,
    [  --enable-debugging      Enables debugging macros],
    [ DEFINE_DEBUG="-DDEBUG" ])
    AC_SUBST(DEFINE_DEBUG)

    AC_PROG_CC
    AC_PROG_INSTALL
    AC_PROG_CPP
    AC_AIX
    AC_PATH_PROG(RM, rm, /bin/rm)
    AC_PATH_PROG(MV, mv, /bin/mv)
    AC_PATH_PROG(TAR, tar, /bin/tar)

    dnl Automatically determine primitive types

    AC_MSG_CHECKING(type to use for int32)
    AC_CACHE_VAL(ac_cv_typeof_int32,
	[AC_TRY_RUN([#include <stdio.h>
	    main(int argc, char *argv[]) {
		char *typ=NULL; FILE *fp=NULL;
		if (sizeof(int) == 4) {
		    typ="int";
		} else if (sizeof(long) == 4) {
		    typ="long";
		} else if (sizeof(short) == 4) {
		    typ="short";
		} else {
		    exit(1);
		}
		fp = fopen("testval.tmp", "w");
		if (fp == NULL) exit(1);
		fprintf(fp, "%s\n", typ);
		fclose(fp);
		exit(0);
	    }],
	ac_cv_typeof_int32=`cat testval.tmp ; rm -f testval.tmp`,
	ac_cv_typeof_int32=UNKNOWN,
	AC_MSG_ERROR(cannot determine type to use for int32))])
    AC_MSG_RESULT($ac_cv_typeof_int32)
    AC_DEFINE_UNQUOTED(EDIR_TYPEOF_INT32, $ac_cv_typeof_int32)

    AC_MSG_CHECKING(type to use for uint32)
    AC_CACHE_VAL(ac_cv_typeof_uint32,
	[AC_TRY_RUN([#include <stdio.h>
	    main(int argc, char *argv[]) {
		char *typ=NULL; FILE *fp=NULL;
		if (sizeof(unsigned) == 4) {
		    typ="unsigned";
		} else if (sizeof(unsigned int) == 4) {
		    typ="unsigned int";
		} else if (sizeof(unsigned long) == 4) {
		    typ="unsigned long";
		} else if (sizeof(unsigned short) == 4) {
		    typ="unsigned short";
		} else {
		    exit(1);
		}
		fp = fopen("testval.tmp", "w");
		if (fp == NULL) exit(1);
		fprintf(fp, "%s\n", typ);
		fclose(fp);
		exit(0);
	    }],
	ac_cv_typeof_uint32=`cat testval.tmp ; rm -f testval.tmp`,
	ac_cv_typeof_uint32=UNKNOWN,
	AC_MSG_ERROR(cannot determine type to use for uint32))])
    AC_MSG_RESULT($ac_cv_typeof_uint32)
    AC_DEFINE_UNQUOTED(EDIR_TYPEOF_UINT32, $ac_cv_typeof_uint32)

    AC_MSG_CHECKING(type to use for int16)
    AC_CACHE_VAL(ac_cv_typeof_int16,
	[AC_TRY_RUN([#include <stdio.h>
	    main(int argc, char *argv[]) {
		char *typ=NULL; FILE *fp=NULL;
		if (sizeof(short) == 2) {
		    typ="short";
		} else if (sizeof(int) == 2) {
		    typ="int";
		} else {
		    exit(1);
		}
		fp = fopen("testval.tmp", "w");
		if (fp == NULL) exit(1);
		fprintf(fp, "%s\n", typ);
		fclose(fp);
		exit(0);
	    }],
	ac_cv_typeof_int16=`cat testval.tmp ; rm -f testval.tmp`,
	ac_cv_typeof_int16=UNKNOWN,
	AC_MSG_ERROR(cannot determine type to use for int16))])
    AC_MSG_RESULT($ac_cv_typeof_int16)
    AC_DEFINE_UNQUOTED(EDIR_TYPEOF_INT16, $ac_cv_typeof_int16)

    AC_MSG_CHECKING(type to use for uint16)
    AC_CACHE_VAL(ac_cv_typeof_uint16,
	[AC_TRY_RUN([#include <stdio.h>
	    main(int argc, char *argv[]) {
		char *typ=NULL; FILE *fp=NULL;
		if (sizeof(unsigned short) == 2) {
		    typ="unsigned short";
		} else if (sizeof(unsigned int) == 2) {
		    typ="unsigned int";
		} else {
		    exit(1);
		}
		fp = fopen("testval.tmp", "w");
		if (fp == NULL) exit(1);
		fprintf(fp, "%s\n", typ);
		fclose(fp);
		exit(0);
	    }],
	ac_cv_typeof_uint16=`cat testval.tmp ; rm -f testval.tmp`,
	ac_cv_typeof_uint16=UNKNOWN,
	AC_MSG_ERROR(cannot determine type to use for uint16))])
    AC_MSG_RESULT($ac_cv_typeof_uint16)
    AC_DEFINE_UNQUOTED(EDIR_TYPEOF_UINT16, $ac_cv_typeof_uint16)

    AC_MSG_CHECKING(pointer printing format)
    AC_CACHE_VAL(ac_cv_pointer_fmt,
	[AC_TRY_RUN([#include <stdio.h>
#include <string.h>
	    main(int argc, char *argv[]) {
		FILE    *fp = NULL;
		char    fmt[100],buf[100];
		char    *ptr = (char *)0x12345678;
		if (sizeof(char *) == 4) {
		    strcpy(fmt, "0x%08x");
		} else if (sizeof(char *) == 8) {
		    strcpy(fmt, "0x%016llx");
		    sprintf(buf, fmt, ptr);
		    if (strcmp(buf, "0x0000000012345678") != 0) {
			if (sizeof(unsigned long) == 8) {
			    strcpy(fmt, "0x%016lx");
			    sprintf(buf, fmt, ptr);
			}
			if ((sizeof(unsigned long) != 8) ||
			    (strcmp(buf, "0x0000000012345678") != 0)) {
			    if (sizeof(unsigned) == 8) {
				strcpy(fmt, "0x%016x");
				sprintf(buf, fmt, ptr);
				if (strcmp(buf, "0x0000000012345678") != 0) {
				    strcpy(fmt, "%p");
				}
			    } else strcpy(fmt, "%p");
			}
		    }
		} else strcpy(fmt, "%p");
		fp = fopen("testval.tmp", "w");
		if (fp == NULL) exit(1);
		fprintf(fp, "\"%s\"\n", fmt);
		fclose(fp);
		exit(0);
	    }],
	ac_cv_pointer_fmt=`cat testval.tmp ; rm -f testval.tmp`,
	ac_cv_pointer_fmt='"%p"',
	AC_MSG_ERROR(cannot determine printf format for pointers))])
    AC_MSG_RESULT($ac_cv_pointer_fmt)
    AC_DEFINE_UNQUOTED(EDIR_PTR, $ac_cv_pointer_fmt)

    dnl Checks for libraries.

    AC_CHECK_FUNC(connect)
    if test $ac_cv_func_connect = no; then
        AC_CHECK_LIB(socket, connect)
    fi

    AC_CHECK_FUNC(gethostbyname)
    if test $ac_cv_func_gethostbyname = no; then
        AC_CHECK_LIB(xnet, gethostbyname)
    fi

    AC_CHECK_FUNC(gethostent)
    if test $ac_cv_func_gethostent = no; then
        AC_CHECK_LIB(nsl, gethostent)
    fi

    AC_CHECK_FUNC(shmat)
    if test $ac_cv_func_shmat = no; then
        AC_CHECK_LIB(ipc, shmat)
    fi

    dnl Checks for header files.

    AC_HEADER_DIRENT
    AC_HEADER_STDC
    AC_TIME_WITH_SYS_TIME
    AC_CHECK_HEADERS(types.h sys/types.h string.h strings.h stdlib.h)
    AC_CHECK_HEADERS(stdarg.h varargs.h)
    AC_CHECK_HEADERS(socket.h sys/socket.h netinet/in.h arpa/inet.h)
    AC_CHECK_HEADERS(errno.h sys/errno.h sys/param.h netdb.h time.h sys/time.h)
    AC_CHECK_HEADERS(unistd.h signal.h sys/signal.h syslog.h sys/mman.h fcntl.h)
    AC_CHECK_HEADERS(sys/stat.h sys/file.h sys/uio.h wait.h sys/wait.h ctype.h)
    AC_CHECK_HEADERS(dirent.h malloc.h ieeefp.h nan.h fp_class.h float.h math.h)
    AC_CHECK_HEADERS(sys/select.h)

    dnl Checks for typedefs, structures, and compiler characteristics.
    AC_C_CONST

    AC_EGREP_HEADER(semun, sys/sem.h, , ac_cv_need_union_semun=yes)

    if test -n "$ac_cv_need_union_semun" ; then
            AC_DEFINE(EDIR_NEED_UNION_SEMUN, 1)
    fi

    dnl Checks for library functions.
    AC_FUNC_STRFTIME
    AC_CHECK_FUNCS(strerror strtol strchr memcpy bcopy mmap snprintf vsnprintf)
    AC_CHECK_FUNCS(getcwd openlog syslog getdtablesize waitpid wait4 wait3 wait)
    AC_CHECK_FUNCS(setenv putenv strcasecmp strcmpi stricmp strncasecmp)
    AC_CHECK_FUNCS(strncmpi strincmp strndup strftime)
    AC_CHECK_FUNCS(finite isnand class localtime)
    AC_FUNC_SETPGRP

    dnl Checks for isnan in libm if not in libc
    AC_CHECK_FUNC(isnan, , AC_CHECK_LIB(m, isnan,
      [M_LIBS="-lm"; AC_DEFINE(HAVE_ISNAN)]))
    AC_SUBST(HAVE_ISNAN)

    AC_CHECK_FUNC(isinf, , AC_CHECK_LIB(m, isinf,
      [M_LIBS="-lm"; AC_DEFINE(HAVE_ISINF)]))
    AC_SUBST(HAVE_ISINF)

    AC_CHECK_FUNC(fpclass, , AC_CHECK_LIB(m, fpclass,
      [M_LIBS="-lm"; AC_DEFINE(HAVE_FPCLASS)]))
    AC_SUBST(HAVE_FPCLASS)

    AC_CHECK_FUNC(fp_class, , AC_CHECK_LIB(m, fp_class,
      [M_LIBS="-lm"; AC_DEFINE(HAVE_FP_CLASS)]))
    AC_SUBST(HAVE_FP_CLASS)

    AC_CHECK_FUNC(fp_class_d, , AC_CHECK_LIB(m, fp_class_d,
      [M_LIBS="-lm"; AC_DEFINE(HAVE_FP_CLASS_D)]))
    AC_SUBST(HAVE_FP_CLASS_D)

    CFLAGS="${CFLAGS} -DXML_USE_BUFFER_CONTENT"
    AC_SUBST(CFLAGS)

    AC_SUBST(M_LIBS)
])

# Do all the work for Automake.  This macro actually does too much --
# some checks are only needed if your package does certain things.
# But this isn't really a big deal.

# serial 1

dnl Usage:
dnl AM_INIT_AUTOMAKE(package,version, [no-define])

AC_DEFUN(AM_INIT_AUTOMAKE,
[AC_REQUIRE([AC_PROG_INSTALL])
PACKAGE=[$1]
AC_SUBST(PACKAGE)
VERSION=[$2]
AC_SUBST(VERSION)
dnl test to see if srcdir already configured
if test "`cd $srcdir && pwd`" != "`pwd`" && test -f $srcdir/config.status; then
  AC_MSG_ERROR([source directory already configured; run "make distclean" there first])
fi
ifelse([$3],,
AC_DEFINE_UNQUOTED(PACKAGE, "$PACKAGE", [Name of package])
AC_DEFINE_UNQUOTED(VERSION, "$VERSION", [Version number of package]))
AC_REQUIRE([AM_SANITY_CHECK])
AC_REQUIRE([AC_ARG_PROGRAM])
dnl FIXME This is truly gross.
missing_dir=`cd $ac_aux_dir && pwd`
AM_MISSING_PROG(ACLOCAL, aclocal, $missing_dir)
AM_MISSING_PROG(AUTOCONF, autoconf, $missing_dir)
AM_MISSING_PROG(AUTOMAKE, automake, $missing_dir)
AM_MISSING_PROG(AUTOHEADER, autoheader, $missing_dir)
AM_MISSING_PROG(MAKEINFO, makeinfo, $missing_dir)
AC_REQUIRE([AC_PROG_MAKE_SET])])

#
# Check to make sure that the build environment is sane.
#

AC_DEFUN(AM_SANITY_CHECK,
[AC_MSG_CHECKING([whether build environment is sane])
# Just in case
sleep 1
echo timestamp > conftestfile
# Do `set' in a subshell so we don't clobber the current shell's
# arguments.  Must try -L first in case configure is actually a
# symlink; some systems play weird games with the mod time of symlinks
# (eg FreeBSD returns the mod time of the symlink's containing
# directory).
if (
   set X `ls -Lt $srcdir/configure conftestfile 2> /dev/null`
   if test "[$]*" = "X"; then
      # -L didn't work.
      set X `ls -t $srcdir/configure conftestfile`
   fi
   if test "[$]*" != "X $srcdir/configure conftestfile" \
      && test "[$]*" != "X conftestfile $srcdir/configure"; then

      # If neither matched, then we have a broken ls.  This can happen
      # if, for instance, CONFIG_SHELL is bash and it inherits a
      # broken ls alias from the environment.  This has actually
      # happened.  Such a system could not be considered "sane".
      AC_MSG_ERROR([ls -t appears to fail.  Make sure there is not a broken
alias in your environment])
   fi

   test "[$]2" = conftestfile
   )
then
   # Ok.
   :
else
   AC_MSG_ERROR([newly created file is older than distributed files!
Check your system clock])
fi
rm -f conftest*
AC_MSG_RESULT(yes)])

dnl AM_MISSING_PROG(NAME, PROGRAM, DIRECTORY)
dnl The program must properly implement --version.
AC_DEFUN(AM_MISSING_PROG,
[AC_MSG_CHECKING(for working $2)
# Run test in a subshell; some versions of sh will print an error if
# an executable is not found, even if stderr is redirected.
# Redirect stdin to placate older versions of autoconf.  Sigh.
if ($2 --version) < /dev/null > /dev/null 2>&1; then
   $1=$2
   AC_MSG_RESULT(found)
else
   $1="$3/missing $2"
   AC_MSG_RESULT(missing)
fi
AC_SUBST($1)])

# Like AC_CONFIG_HEADER, but automatically create stamp file.

AC_DEFUN(AM_CONFIG_HEADER,
[AC_PREREQ([2.12])
AC_CONFIG_HEADER([$1])
dnl When config.status generates a header, we must update the stamp-h file.
dnl This file resides in the same directory as the config header
dnl that is generated.  We must strip everything past the first ":",
dnl and everything past the last "/".
AC_OUTPUT_COMMANDS(changequote(<<,>>)dnl
ifelse(patsubst(<<$1>>, <<[^ ]>>, <<>>), <<>>,
<<test -z "<<$>>CONFIG_HEADERS" || echo timestamp > patsubst(<<$1>>, <<^\([^:]*/\)?.*>>, <<\1>>)stamp-h<<>>dnl>>,
<<am_indx=1
for am_file in <<$1>>; do
  case " <<$>>CONFIG_HEADERS " in
  *" <<$>>am_file "*<<)>>
    echo timestamp > `echo <<$>>am_file | sed -e 's%:.*%%' -e 's%[^/]*$%%'`stamp-h$am_indx
    ;;
  esac
  am_indx=`expr "<<$>>am_indx" + 1`
done<<>>dnl>>)
changequote([,]))])

