/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * $Id: edir.h,v 1.1 2003/04/14 12:25:56 sinisa Exp $
 */
#ifndef __EDIR_H__
#define __EDIR_H__ 1
#ifdef __cplusplus
extern "C" {
#endif

#define EDIR_MAX(A,B)  (((A) > (B)) ? (A) : (B))
#define EDIR_MIN(A,B)  (((A) < (B)) ? (A) : (B))

#define EDIR_AUTH_MAX	100
#define EDIR_NAME_MAX	512

#define EDIR_TIMEDIFF(T1, T2) ( ((((int32)(T1)) - ((int32)(T2))) >= 0) ? \
			       (((int32)(T1)) - ((int32)(T2))) : \
			       (((int32)(T2)) - ((int32)(T1))) )
/**
 * XXX This really belongs in edir_httpd.h, but due to circularities,
 * I'm putting it here.
 */
typedef void * edir_httpd_ctx;

#include "edir_config.h"
#include "edir_exception.h"
#include "edir_state.h"
#include "edir_proto.h"
#include "edir_socket.h"
#include "edir_memory.h"
#include "edir_string.h"
#include "edir_md5.h"
#include "edir_client.h"
#include "edir_conf.h"

#ifndef EDIR_MULTITHREADED
#include "edir_ipc.h"
#include "edir_mutex.h"
#include "edir_shmem.h"
#include "edir_refcount.h"
#endif

#include "edir_load_scoreboard.h"

#ifndef EDIR_MULTITHREADED
#include "edir_daemon.h"
#include "edir_load_multiproc.h"
#endif

#include "edir_load_choose.h"
#include "edir_load.h"
#include "edir_cookie_b64.h"
#include "edir_log.h"
#include "edir_debug.h"
#include "edir_table.h"
#include "edir_kvtable.h"
#include "edir_load_status.h"


#ifdef __cplusplus
} /* Extern "C" */
#endif
#endif /* __EDIR_H__ */

