/* MD5.H - header file for MD5C.C
 */

/* Copyright (C) 1991, RSA Data Security, Inc. All rights reserved.

   License to copy and use this software is granted provided that it
   is identified as the "RSA Data Security, Inc. MD5 Message-Digest
   Algorithm" in all material mentioning or referencing this software
   or this function.

   License is also granted to make and use derivative works provided
   that such works are identified as "derived from the RSA Data
   Security, Inc. MD5 Message-Digest Algorithm" in all material
   mentioning or referencing the derived work.  
                                                                    
   RSA Data Security, Inc. makes no representations concerning either
   the merchantability of this software or the suitability of this
   software for any particular purpose. It is provided "as is"
   without express or implied warranty of any kind.  
                                                                    
   These notices must be retained in any copies of any part of this
   documentation and/or software.  
   
   Enhydra - Modified function and type names with prefix of 'edir_'
   to prevent conflict with other unknown modules using their own
   copy of md5.  No modifications of algoritm or functionality have 
   been done.
 */
#ifndef __MD5_H__
#define __MD5_H__ 1
#ifdef __cplusplus
extern "C" {
#endif

/* MD5 context. */
typedef struct {
  uint32 state[4];                                           /* state (ABCD) */
  uint32 count[2];                /* number of bits, modulo 2^64 (lsb first) */
  unsigned char buffer[64];                                 /* input buffer */
} edir_MD5_CTX;

void edir_MD5Init(edir_MD5_CTX *);
void edir_MD5Update(edir_MD5_CTX *, unsigned char *, unsigned int);
void edir_MD5Final(unsigned char [16], edir_MD5_CTX *);
void edir_MD5(octet * hash_out, octet * bytes_in, unsigned long len);

#ifdef __cplusplus
} /* Extern "C" */
#endif
#endif /* __MD5_H__ */
