/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * $Id: edir_socket.h,v 1.1 2003/04/14 12:25:59 sinisa Exp $
 */

#ifndef __EDIR_SOCKET_H__
#define __EDIR_SOCKET_H__ 1
#ifdef __cplusplus
extern "C" {
#endif

extern void
edir_socket(edir_connection_t *conn, edir_exception_t **exc);

extern void
edir_socket_bind(edir_connection_t *conn, edir_exception_t **exc);

extern void
edir_socket_connect(edir_connection_t *conn, edir_exception_t **exc);

extern void
edir_socket_close(edir_connection_t *conn, edir_exception_t **exc);

extern void
edir_socket_write(edir_connection_t *conn, edir_exception_t **exc,
		void *buf, int32 len);

extern void
edir_socket_write_sbuf(edir_connection_t *conn, edir_exception_t **exc, void *sbuf);

extern void
edir_socket_receive(edir_connection_t *conn, edir_exception_t **exc,
		void *buf, int32 len);

extern void
edir_socket_receive_all(edir_connection_t *conn, edir_exception_t **exc,
		void *buf, int32 len);

extern void
edir_socket_skip(edir_connection_t *conn, edir_exception_t **exc, int32 len);

extern void
edir_socket_skip_all(edir_connection_t *conn, edir_exception_t **exc, int32 len);

extern void
edir_socket_finish_skip(edir_connection_t *conn, edir_exception_t **exc);

extern void
edir_socket_finish_send(edir_connection_t *conn, edir_exception_t **exc);

extern void
edir_socket_finish_receive(edir_connection_t *conn, edir_exception_t **exc);

extern void
edir_socket_finish_connect(edir_connection_t *conn, edir_exception_t **exc);

extern int
edir_ip_addr(char *hostname, struct in_addr *ap);

extern void
edir_sockaddr_in(char *host, int port, struct sockaddr_in *sin,
	       edir_exception_t **exc);

extern void 
edir_sockaddr_to_str(struct sockaddr_in *sin, char *buf);

#define EDIR_IO_PENDING(CONN) ((CONN)->ioPending)

#define EDIR_SOCKET_MAX_IOV 10

#ifdef __cplusplus
} /* Extern "C" */
#endif
#endif  /* __EDIR_SOCKET_H__ */
