@echo off

rem
rem The multiserver startup script.
rem
rem  multiserver [-help] [-nojit] [-debug] [-java-arg arg] [config-file]
rem
rem  -help - Print usage message and exit.
rem  -nojit - Don't used a JIT (set -Djava.compiler=NONE)
rem  -debug - Enable debugging (assumes Sun JVM options)
rem  -java-arg arg - Pass the argument to the java.  Maybe specified
rem   multiple times.
rem
rem config-file - multiserver configuration file.
rem

set USAGE=multiserver [-help] [-nojit] [-debug] [-java-arg arg] [config-file]

call C:\vpuskas\beta8\enhydra-5.1\Enhydra\output\enhydra5.1\bin\setclass.bat


set JDKDIR=C:\j2sdk1.4.0
set JAVA="%JDKDIR%\bin\java"
set ENHYDRA_DIR=C:\vpuskas\beta8\enhydra-5.1\Enhydra\output\enhydra5.1

rem For Enhydra development use the classes directory instead of the jar file.
set ENHYDRA_CLASSES=C:\vpuskas\beta8\enhydra-5.1\Enhydra\output\enhydra5.1\lib\enhydra.jar
set DEFAULT_CONFIGFILE=%ENHYDRA_DIR%\multiserver_runtime.conf
set MAINCLASS=com.lutris.multiServer.MultiServer



rem Parse arguments
set USE_JIT=YES
set DEBUG=NO
set JAVA_ARGS=

:start
if %1.==. goto continue1
if %1==-nojit goto nojit
if %1==-debug goto debug
if %1==-java-arg goto java-arg
if %1==-help goto help
if %1==-- goto continue0
if %1==-* goto error2
if %1==* goto continue1
goto continue1

:nojit
shift
set USE_JIT=NO
goto start

:debug
shift
set USE_JIT=NO
set DEBUG=YES
goto start

:java-arg
shift
if %1.==. goto error1
set JAVA_ARGS=%JAVA_ARGS% %1
shift
goto start

:help
echo.
echo %USAGE%
echo.
goto exit 

:error1
echo Error: -java-arg requires an argument
echo %USAGE%
goto exit 

:error2
echo Error: invalid option \%1\
echo %USAGE%
goto exit 

:continue0
shift

:continue1
rem Check for too many parameters
if %2.==. goto continue2
echo "Error: Wrong rem of args: %USAGE%
goto exit 

:continue2
rem Set config file parameter
if %1.==. goto defaultconf
set file=%1
goto configfile

:defaultconf
set file=%DEFAULT_CONFIGFILE%

:configfile
set CONFIGFILE=%file%

set WIN=YES

rem Check for java
if exist "%JDKDIR%\bin\java.exe" goto continue3
echo "Error: Cannot find Java VM."
goto exit 

:continue3 
rem Check for enhydra directory
if exist %ENHYDRA_DIR%\*.* goto continue4
echo "Error: Cannot find Enhydra directory."
goto exit 

:continue4
rem Check for the Enhydra classes
if exist %ENHYDRA_CLASSES% goto continue5
echo Error: Cannot find Enhydra classes.
goto exit 

:continue5
if %USE_JIT%==NO set JAVA_ARGS=%JAVA_ARGS% -Djava.compiler=NONE


if %DEBUG% == YES set JAVA_ARGS=%JAVA_ARGS% -Xdebug -Xbootclasspath;%JDKDIR%\jre\lib\rt.jar;%JDKDIR%\lib\tools.jar

rem
rem Build up classpath.
rem
if  "X%CLASSPATH%" == "X" goto setx
set NEWCP=%ENHYDRA_CLASSES%;%CLASSPATH%
goto continue6

:setx
set NEWCP=%ENHYDRA_CLASSES%

:continue6

set CLASSPATH=%NEWCP%

rem Don't use -classpath while 1.1 is still supported.
echo %JAVA% %JAVA_ARGS% %MAINCLASS% %CONFIGFILE%

%JAVA% %JAVA_ARGS% -Denhydra.home=%ENHYDRA_DIR% %MAINCLASS% %CONFIGFILE%

:exit
C:\vpuskas\beta8\enhydra-5.1\Enhydra\output\enhydra5.1\bin\unsetclass.bat
