////////////////////////////////////////////////////////////////////////////////
// File : EnTray.cpp
////////////////////////////////////////////////////////////////////////////////
// Program : EnTray
////////////////////////////////////////////////////////////////////////////////
// Version : 0.14b3                    * Author : L.Stricevic
// Date    : 31.03.2003.
//
//
//
//
////////////////////////////////////////////////////////////////////////////////
// Defines the entry point for the application.
//
////////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <windowsx.h>
#include <winsvc.h>
#include "SHELLAPI.h"
#include "resource.h"
#include <stdio.h>
#include <process.h>

#define MAX_LOADSTRING 100

///////////////////////////////////////////////////////////////////////////////
// Service defs
#define SZSERVICENAME "MultiServer"
#define ID_SERVICE_UNKNOWN 6
#define ID_SERVICE_STOP_PENDING 5
#define ID_SERVICE_START_PENDING 4
#define ID_SERVICE_PAUSED 3
#define ID_SERVICE_RUNNING 2
#define ID_SERVICE_STOPPED 1
#define ID_NO_SERVICE 0
#define ID_SERVICE_ERROR (-1)
#define ID_VER_STRING "Version 0.14b3"
#define ID_STRING "Made by Lazar Stricevic"
#define REG_RUN_SUBKEY "Software\\Microsoft\\Windows\\CurrentVersion\\Run"
#define REG_RUN_KEYNAME "EnhydraTrayIndicator"

///////////////////////////////////////////////////////////////////////////////
// Message ID used for tray notifications
#define WM_MY_TRAY_NOTIFICATION (WM_USER+100)

///////////////////////////////////////////////////////////////////////////////
// Timer ID
#define ID_TASKBAR_TIMER 39

///////////////////////////////////////////////////////////////////////////////
// TrayIcon ID
#define ID_TRAYICON     1000


///////////////////////////////////////////////////////////////////////////////
// MenuItem defs

#define MAX_LD_ITEMS 20
#define MAX_LD_CAP_SIZE 50
#define MAX_LD_URL_SIZE 200


///////////////////////////////////////////////////////////////////////////////
// Global Variables:
HINSTANCE hInst;						// current instance
HMENU hMenuDummy;						// Menu
HMENU hMenu;							// Popup menu
TCHAR szWindowClass[MAX_LOADSTRING];	// Window class name
TCHAR szSplashScreenClass[MAX_LOADSTRING];  // Splashscreen class name

HWND hMainWnd = NULL;

HWND hSplashWnd = NULL;               // Splash screen
HBITMAP hBmp = NULL;
BITMAP bm;
BOOL bSplash = FALSE;
BOOL bQuit = FALSE;


int iEnServState;

// Menuitem vars (loaded from file)

struct {
	int id;
	char caption[MAX_LD_CAP_SIZE];
	char url[MAX_LD_URL_SIZE];
} LdItems[MAX_LD_ITEMS];
int LdItemsNum = 0;

// Icon file name and caption vars
#define KEY_BUFF_SIZE 255
char szStartedIconFName[KEY_BUFF_SIZE];
char szStartingIconFName[KEY_BUFF_SIZE];
char szStoppedIconFName[KEY_BUFF_SIZE];
char szStoppingIconFName[KEY_BUFF_SIZE];
char szStartedCaption[KEY_BUFF_SIZE];
char szStartingCaption[KEY_BUFF_SIZE];
char szStoppedCaption[KEY_BUFF_SIZE];
char szStoppingCaption[KEY_BUFF_SIZE];


///////////////////////////////////////////////////////////////////////////////
// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK    SplashWndProc(HWND, UINT, WPARAM, LPARAM);
int					EnServiceGetState();


///////////////////////////////////////////////////////////
// FUNCTION: LoadIconProp()
//
// Loads icon properties (file names ad captions
//
// Added 25.03.2003

void LoadIconProp(void)
{

	char szBuff[KEY_BUFF_SIZE];
	char *szAppName="EnTray";
	char *szIniFName="EnTray.ini";

	// Icon path name load
	LoadString(hInst, IDS_INAME_STARTED, szBuff, sizeof(szBuff));
	GetPrivateProfileString(szAppName, "StartedIconPathName", szBuff, szStartedIconFName, KEY_BUFF_SIZE-1, szIniFName);

	LoadString(hInst, IDS_INAME_STARTING, szBuff, sizeof(szBuff));
	GetPrivateProfileString(szAppName, "StartingIconPathName", szBuff, szStartingIconFName, KEY_BUFF_SIZE-1, szIniFName);

	LoadString(hInst, IDS_INAME_STOPPED, szBuff, sizeof(szBuff));
	GetPrivateProfileString(szAppName, "StoppedIconPathName", szBuff, szStoppedIconFName, KEY_BUFF_SIZE-1, szIniFName);

	LoadString(hInst, IDS_INAME_STOPPING, szBuff, sizeof(szBuff));
	GetPrivateProfileString(szAppName, "StoppingIconPathName", szBuff, szStoppingIconFName, KEY_BUFF_SIZE-1, szIniFName);


	// Caption load
	LoadString(hInst, IDI_MULTISERVER_STARTED, szBuff, sizeof(szBuff));
	GetPrivateProfileString(szAppName, "StartedCaption", szBuff, szStartedCaption, KEY_BUFF_SIZE-1, szIniFName);

	LoadString(hInst, IDI_MULTISERVER_STARTING, szBuff, sizeof(szBuff));
	GetPrivateProfileString(szAppName, "StartingCaption", szBuff, szStartingCaption, KEY_BUFF_SIZE-1, szIniFName);

	LoadString(hInst, IDI_MULTISERVER_STOPPED, szBuff, sizeof(szBuff));
	GetPrivateProfileString(szAppName, "StoppedCaption", szBuff, szStoppedCaption, KEY_BUFF_SIZE-1, szIniFName);

	LoadString(hInst, IDI_MULTISERVER_STOPPING, szBuff, sizeof(szBuff));
	GetPrivateProfileString(szAppName, "StoppingCaption", szBuff, szStoppingCaption, KEY_BUFF_SIZE-1, szIniFName);


}


///////////////////////////////////////////////////////////
// FUNCTION: LoadAppMenuItems(HWND hWnd, HMENU hMenu)
//
// Loads menu items and appends it to menu
//
// Added 25.03.2003


//
#define MAX_LINE_SIZE 255
#define MY_ID_START 300
#define LDI_FNAME "EnTray.txt"

void LoadAppMenuItems(HWND hWnd, HMENU hMenu)
{
	char line[MAX_LINE_SIZE];
	char *caption;
	char *url;
	int i;
	TCHAR szMyPathName[_MAX_PATH+1]="";
	TCHAR szMyFullPath[_MAX_PATH+1]="";
	LPTSTR lpszMyFileN;
	FILE *fs;

	for(i=0;i<LdItemsNum;i++){
		RemoveMenu(hMenu, LdItems[i].id, MF_BYCOMMAND);
		DrawMenuBar(hWnd);
	}

	iEnServState=EnServiceGetState();
	if(iEnServState != ID_SERVICE_RUNNING) return;

	GetModuleFileName(NULL, szMyPathName, _MAX_PATH);
	GetFullPathName(szMyPathName, _MAX_PATH, szMyFullPath, &lpszMyFileN);
	strcpy(lpszMyFileN, LDI_FNAME);

	LdItemsNum=0;
	if( (fs = fopen( szMyFullPath, "r" )) != NULL ){
		for(;;){
			if( fgets( line, MAX_LINE_SIZE, fs ) != NULL){
				url=strchr(line,',');
				if(url==NULL) break;
				*url='\0';
				url++;
				caption=line;

				strncpy(LdItems[LdItemsNum].caption, caption, MAX_LD_CAP_SIZE);
				strncpy(LdItems[LdItemsNum].url, url, MAX_LD_URL_SIZE);
				LdItems[LdItemsNum].id = LdItemsNum + MY_ID_START;

				AppendMenu(hMenu,MF_STRING,
					LdItems[LdItemsNum].id,
					LdItems[LdItemsNum].caption);
				DrawMenuBar(hWnd);

				LdItemsNum++;
			}
			else
				break;
		}
		fclose( fs );
	}
}




///////////////////////////////////////////////////////////////////////////////
// Registry functions
///////////////////////////////////////////////////////////////////////////////

BOOL RegisterStartUp(void)
{
	HKEY   hk;
	DWORD  dwDisp;
	char szMyPathName[_MAX_PATH+1]="";

	GetModuleFileName(NULL, szMyPathName, _MAX_PATH);

	if (RegCreateKeyEx( HKEY_LOCAL_MACHINE,
			REG_RUN_SUBKEY,
			0,
			NULL,
			REG_OPTION_NON_VOLATILE,
			KEY_WRITE,
			NULL,
			&hk,
			&dwDisp))
		return FALSE;


	RegSetValueEx( hk,
		REG_RUN_KEYNAME,
		0,
		REG_SZ,
		(CONST BYTE *)szMyPathName,
		strlen(szMyPathName)+1 );

	RegCloseKey(hk);

	return TRUE;

}


BOOL UnRegisterStartUp()
{
	HKEY   hk;
	DWORD  dwDisp;

	if (RegCreateKeyEx( HKEY_LOCAL_MACHINE,
			REG_RUN_SUBKEY,
			0,
			NULL,
			REG_OPTION_NON_VOLATILE,
			KEY_WRITE,
			NULL,
			&hk,
			&dwDisp))
		return FALSE;


	RegDeleteValue( hk, REG_RUN_KEYNAME);

	RegCloseKey(hk);

	return TRUE;

}

BOOL CheckID()
{
	static char szID[]=ID_STRING;
	static char szVersionID[]=ID_VER_STRING;
	int i;
	int s=0;

	for(i=0;szID[i]!='\0';i++)
		s+=szID[i];

	if(s==2136)
		return TRUE;
	else
		return FALSE;
	szVersionID[0]=toupper(szVersionID[0]);
}

////////////////////////////////////////////////////////////////
// Service interface functios
////////////////////////////////////////////////////////////////////////////////
//
//

int EnServiceGetState()
{
	
    SC_HANDLE   schService;
    SC_HANDLE   schSCManager;
	int			RetVal=ID_SERVICE_ERROR;
	SERVICE_STATUS ssStatus;

    schSCManager = OpenSCManager(
                        NULL,                   // machine (NULL == local)
                        NULL,                   // database (NULL == default)
                        SC_MANAGER_CONNECT   // access required
                        );
    if ( schSCManager )
    {
        schService = OpenService(schSCManager, TEXT(SZSERVICENAME), SERVICE_QUERY_STATUS);

        if (schService)
        {
			if(QueryServiceStatus(schService, &ssStatus))
				switch(ssStatus.dwCurrentState){
					case SERVICE_STOPPED: RetVal= ID_SERVICE_STOPPED;
						break;
					case SERVICE_RUNNING: RetVal= ID_SERVICE_RUNNING;
						break;
					case SERVICE_PAUSED: RetVal= ID_SERVICE_PAUSED;
						break;
					case SERVICE_STOP_PENDING: RetVal=ID_SERVICE_STOP_PENDING;
						break;
					case SERVICE_START_PENDING: RetVal=ID_SERVICE_START_PENDING;
						break;
					default: RetVal=ID_SERVICE_UNKNOWN;
						break;
				}


            CloseServiceHandle(schService);
        }
        else
			RetVal=ID_NO_SERVICE;
 
        CloseServiceHandle(schSCManager);
    }
    else
		RetVal=ID_SERVICE_ERROR;

	return RetVal;
}

BOOL EnServiceStart()
{
	
    SC_HANDLE   schService;
    SC_HANDLE   schSCManager;
	BOOL		RetVal=TRUE;

    schSCManager = OpenSCManager(
                        NULL,                   // machine (NULL == local)
                        NULL,                   // database (NULL == default)
                        SC_MANAGER_ALL_ACCESS   // access required
                        );
    if ( schSCManager )
    {
        schService = OpenService(schSCManager, TEXT(SZSERVICENAME), SERVICE_ALL_ACCESS);

        if (schService)
        {
			StartService(schService, 0, NULL);
            CloseServiceHandle(schService);
        }
        else
			RetVal=FALSE;
 
        CloseServiceHandle(schSCManager);
    }
    else
		RetVal=FALSE;

	return RetVal;
}

BOOL EnServiceStop()
{
	
    SC_HANDLE   schService;
    SC_HANDLE   schSCManager;
	BOOL		RetVal=TRUE;
	SERVICE_STATUS ssStatus;

    schSCManager = OpenSCManager(
                        NULL,                   // machine (NULL == local)
                        NULL,                   // database (NULL == default)
                        SC_MANAGER_ALL_ACCESS   // access required
                        );
    if ( schSCManager )
    {
        schService = OpenService(schSCManager, TEXT(SZSERVICENAME), SERVICE_ALL_ACCESS);
        if (schService)
        {
			ControlService(schService, SERVICE_CONTROL_STOP, &ssStatus);
            CloseServiceHandle(schService);
        }
        else
			RetVal=FALSE;
 
        CloseServiceHandle(schSCManager);
    }
    else
		RetVal=FALSE;

	return RetVal;
}



////////////////////////////////////////////////////////////////////////////////
// Tray functions
////////////////////////////////////////////////////////////////////////////////
//
//

BOOL TrayMessage(HWND hWnd, DWORD dwMessage, HICON hIcon, PSTR pszTip)
{
    BOOL res;

    NOTIFYICONDATA tnd;

    tnd.cbSize		= sizeof(NOTIFYICONDATA);
    tnd.hWnd		= hWnd;
    tnd.uID			= ID_TRAYICON;

    tnd.uFlags		= NIF_MESSAGE|NIF_ICON|NIF_TIP;
    tnd.uCallbackMessage	= WM_MY_TRAY_NOTIFICATION;
    tnd.hIcon		= hIcon;
    lstrcpyn(tnd.szTip, pszTip, sizeof(tnd.szTip));

    res = Shell_NotifyIcon(dwMessage, &tnd);

    if (hIcon)
        DestroyIcon(hIcon);

    return res;
}

///////////////////////////////////////////////////////////////////////////////
//
//
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
//    BOOL bEnabled;
    BOOL bClassRegistered = FALSE;

    hMenuDummy = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_TRAYICON));
    hMenu = GetSubMenu(hMenuDummy, 0);

	// Initialize global strings
	LoadString(hInstance, IDR_TRAYICON, szWindowClass, MAX_LOADSTRING);
//    LoadString(hInstance, IDR_SPLASHSCREEN, szSplashScreenClass, MAX_LOADSTRING);
	if(!CheckID())
		return FALSE;

	// Do not allow a second instance
	if (FindWindow(szWindowClass,NULL) != NULL)
		return FALSE;

	iEnServState=EnServiceGetState();
	if(iEnServState==ID_NO_SERVICE || iEnServState==ID_SERVICE_ERROR)
		return FALSE;

	// If the command line is 'install', write to registry.
	if (stricmp(lpCmdLine, "install") == 0)
	{
		RegisterStartUp();
	}
	else if (stricmp(lpCmdLine, "uninstall") == 0)
	{
		UnRegisterStartUp();
		return FALSE;
	}

	if (MyRegisterClass(hInstance) != 0)
        bClassRegistered = TRUE;

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
        TranslateMessage(&msg);
		DispatchMessage(&msg);
	}


    // Release the wndclass name
    if(bClassRegistered)
		UnregisterClass(szWindowClass,hInstance);
	
    return msg.wParam;
}



///////////////////////////////////////////////////////////////////////////////
//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= NULL;
	wcex.hCursor		= NULL;
	wcex.hbrBackground	= NULL;
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= NULL;

	return RegisterClassEx(&wcex);
}


///////////////////////////////////////////////////////////////////////////////
//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   hInst = hInstance; // Store instance handle in our global variable

   hMainWnd = CreateWindow(szWindowClass, "", WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hMainWnd)
   {
      return FALSE;
   }

   // Create the splash screen here

   // Don't show the window !!
   UpdateWindow(hMainWnd);

   return TRUE;
}


///////////////////////////////////////////////////////////////////////////////
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent, i;
	POINT mouse;
    char szBuff[64];
	char *szFName=NULL;
	char *szCaption=NULL;
    UINT nResource;
    HICON hIcon;
    BOOL bEnabled;
	BOOL MenuUsed=FALSE;


	switch (message)
	{
        case WM_CREATE:
			LoadIconProp(); // loads icon file names an captions

			bQuit=FALSE;
			iEnServState=EnServiceGetState();
			switch(iEnServState){
			case ID_SERVICE_RUNNING:
				nResource=IDI_MULTISERVER_STARTED;
				szFName=szStartedIconFName;
				szCaption=szStartedCaption;

				break;
			case ID_SERVICE_START_PENDING:
				nResource=IDI_MULTISERVER_STARTING;
				szFName=szStartingIconFName;
				szCaption=szStartingCaption;

				break;
			case ID_SERVICE_STOP_PENDING:
				nResource=IDI_MULTISERVER_STOPPING;
				szFName=szStoppingIconFName;
				szCaption=szStoppingCaption;

				break;
			default:
				nResource=IDI_MULTISERVER_STOPPED;
				szFName=szStoppedIconFName;
				szCaption=szStoppedCaption;

				break;
			}

			hIcon = (HICON)LoadImage(hInst, szFName, IMAGE_ICON, 16, 16, LR_LOADFROMFILE);
			if(hIcon==NULL)
				hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(nResource), IMAGE_ICON, 16, 16, 0);
            TrayMessage(hWnd, NIM_ADD, NULL, NULL);
			TrayMessage(hWnd, NIM_MODIFY, hIcon, szCaption);

			SetTimer(hWnd, ID_TASKBAR_TIMER, 1039, NULL);
            break;

        case WM_TIMER:
			if (wParam ==ID_TASKBAR_TIMER) {
				if(bQuit){
					KillTimer(hWnd, ID_TASKBAR_TIMER);
					TrayMessage(hWnd, NIM_DELETE, NULL, NULL);
					DestroyWindow(hWnd);
				}
				else{
					iEnServState=EnServiceGetState();
					switch(iEnServState){
					case ID_SERVICE_RUNNING:
						nResource=IDI_MULTISERVER_STARTED;
						szFName=szStartedIconFName;
						szCaption=szStartedCaption;

						break;
					case ID_SERVICE_START_PENDING:
						nResource=IDI_MULTISERVER_STARTING;
						szFName=szStartingIconFName;
						szCaption=szStartingCaption;

						break;
					case ID_SERVICE_STOP_PENDING:
						nResource=IDI_MULTISERVER_STOPPING;
						szFName=szStoppingIconFName;
						szCaption=szStoppingCaption;

						break;
					case ID_SERVICE_STOPPED:
						nResource=IDI_MULTISERVER_STOPPED;
						szFName=szStoppedIconFName;
						szCaption=szStoppedCaption;

						break;
					default:
						bQuit=TRUE;
						nResource=IDI_MULTISERVER_STOPPED;
						szFName=szStoppedIconFName;
						szCaption=szStoppedCaption;
						break;
					}

					hIcon = (HICON)LoadImage(hInst, szFName, IMAGE_ICON, 16, 16, LR_LOADFROMFILE);
					if(hIcon==NULL)
						hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(nResource), IMAGE_ICON, 16, 16, 0);
					TrayMessage(hWnd, NIM_MODIFY, hIcon, szCaption);
				}

			}
            break;

        case WM_COMMAND:
			wmId    = LOWORD(wParam);
			wmEvent = HIWORD(wParam);
			// Parse the menu selections:
			switch (wmId)
			{
                case IDM_TRAY_ENABLESERVICE:
					iEnServState=EnServiceGetState();
					switch(iEnServState){
					case ID_SERVICE_RUNNING:
						nResource=IDI_MULTISERVER_STARTED;
						szFName=szStartedIconFName;
						szCaption=szStartedCaption;

						EnServiceStop();
						break;
					case ID_SERVICE_START_PENDING:
						nResource=IDI_MULTISERVER_STARTING;
						szFName=szStartingIconFName;
						szCaption=szStartingCaption;
						break;
					case ID_SERVICE_STOP_PENDING:
						nResource=IDI_MULTISERVER_STOPPING;
						szFName=szStoppingIconFName;
						szCaption=szStoppingCaption;
						break;
					default:
						nResource=IDI_MULTISERVER_STOPPED;
						szFName=szStoppedIconFName;
						szCaption=szStoppedCaption;
						EnServiceStart();
						break;
					}

					hIcon = (HICON)LoadImage(hInst, szFName, IMAGE_ICON, 16, 16, LR_LOADFROMFILE);
					if(hIcon==NULL)
						hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(nResource), IMAGE_ICON, 16, 16, 0);
					TrayMessage(hWnd, NIM_MODIFY, hIcon, szCaption);
				    break;

				case IDM_EXIT:
					bQuit=TRUE;
					break;
			    default:
					for(i=0;i<LdItemsNum;i++){
						if(wmId == LdItems[i].id){
							_spawnlp(_P_NOWAIT, "explorer", "explorer", LdItems[i].url, NULL);
							MenuUsed=TRUE;
						}
					}
					if(!MenuUsed)
						return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;

        case WM_MY_TRAY_NOTIFICATION:
		    switch (lParam )
            {
			case WM_RBUTTONUP:
				iEnServState=EnServiceGetState();
				if(iEnServState==ID_SERVICE_RUNNING){
					nResource=IDI_MULTISERVER_STARTED;
					bEnabled=TRUE;
				} else if(iEnServState==ID_SERVICE_STOPPED){
					nResource=IDI_MULTISERVER_STOPPED;
					bEnabled=FALSE;
				} else break;


				nResource = bEnabled ? IDI_STOP_SERVICE : IDI_START_SERVICE;

				LoadString(hInst, nResource, szBuff, sizeof(szBuff));

				ModifyMenu(hMenu, IDM_TRAY_ENABLESERVICE, MF_BYCOMMAND | MF_STRING, IDM_TRAY_ENABLESERVICE, szBuff);

				LoadAppMenuItems(hWnd, hMenu);


				// Make first menu item the default (bold font)
				SetMenuDefaultItem(hMenu, 0, TRUE);

				// Display the menu at the current mouse location. There's a "bug"
				// (Microsoft calls it a feature) in Windows 95 that requires calling
				// SetForegroundWindow. To find out more, search for Q135788 in MSDN.
				SetForegroundWindow(hWnd);
				GetCursorPos(&mouse);
				TrackPopupMenu(hMenu, 0, mouse.x, mouse.y, 0, hWnd, NULL);
				break;

			case WM_LBUTTONDBLCLK:
				SetForegroundWindow(hWnd);
				SendMessage(hWnd, WM_COMMAND, GetMenuItemID(hMenu, 0), 0);
				break;
            }
		    break;

        case WM_DESTROY:
			PostQuitMessage(0);
			break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

