package com.lutris.multiServer;
import com.lutris.multiServer.MultiServer;
import com.silveregg.wrapper.WrapperListener;
import com.silveregg.wrapper.WrapperManager;

public class Main implements WrapperListener {
    private static Main _instance;
/*    
		static DesktopIndicatorTest listener;
  	static DesktopIndicator indicator;
*/    
    /*---------------------------------------------------------------
     * Constructors
     *-------------------------------------------------------------*/
    private Main() {
    }

    /*---------------------------------------------------------------
     * WrapperListener Methods
     *-------------------------------------------------------------*/
    public Integer start(String[] args) {
        //System.out.println("Web-Based Administration Tool...");

        // This startup could take a while, so tell the wrapper to be patient.
        WrapperManager.signalStarting(45000);

        MultiServer.main(args);

        // We are almost up now, so reset the wait time
        WrapperManager.signalStarting(2000);

        return null;
    }

    public int stop(int exitCode) {

        // The Multiserver does not work the way Wrapper is expecting.
        //  As a result, we need to send a message to the native Wrapper
        //  code so that it is not surprised when the JVM shutsdown.
        WrapperManager.signalStopped(exitCode);

        MultiServer.shutdown();
				
        // Will not get back here.
        return exitCode;
    }

    /**
     * Called whenever the native wrapper code traps a system control signal
     *  against the Java process.  It is up to the callback to take any
     *  actions necessary.  Possible values are:
     *    WrapperManager.WRAPPER_CTRL_C_EVENT, WRAPPER_CTRL_CLOSE_EVENT,
     *    WRAPPER_CTRL_LOGOFF_EVENT, or WRAPPER_CTRL_SHUTDOWN_EVENT
     */
    public void controlEvent(int event) {
        if (WrapperManager.isControlledByNativeWrapper()) {
            // This application ignores all incoming control events.
            //  It relies on the wrapper code to handle them.
        } else {
            WrapperManager.stop(0);
        }
    }


    /*---------------------------------------------------------------
     * Main Method
     *-------------------------------------------------------------*/
    public static void main(String[] args) {
        WrapperManager.start(new Main(), args);
    }
}