package com.silveregg.wrapper;

/*
 * Copyright (c) 2001 Silver Egg Technology
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without 
 * restriction, including without limitation the rights to use, 
 * copy, modify, merge, publish, distribute, sublicense, and/or 
 * sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following 
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT 
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */

// $Log: WrapperInfo.java,v $
// Revision 1.1  2003/04/14 12:32:23  sinisa
// *** empty log message ***
//
// Revision 1.1  2003/02/28 14:51:12  sinisa
// *** empty log message ***
//
// Revision 1.1.1.1  2001/11/07 08:54:20  mortenson
// no message
//

import java.util.Calendar;
import java.util.Date;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.text.ParseException;

/**
 * WrapperInfo.java is build as part of the build process and should not be
 *  modified.  Any changes to this class should be made to WrapperInfo.java.in
 */
final class WrapperInfo {
    private static final String   _version         = "2.3.0a";
    private static final Calendar _build           = Calendar.getInstance();
    
    static {
        Calendar buildDate = Calendar.getInstance();
        Calendar buildTime = Calendar.getInstance();
        try {
            buildDate.setTime(new SimpleDateFormat("yyyyMMdd").parse("20021207"));
            buildTime.setTime(new SimpleDateFormat("HHmm").parse("2342"));
            
            _build.set(buildDate.get(Calendar.YEAR), 
                       buildDate.get(Calendar.MONTH), 
                       buildDate.get(Calendar.DATE),
                       buildTime.get(Calendar.HOUR),
                       buildTime.get(Calendar.MINUTE));

        } catch (ParseException e) {
            System.out.println("Can not parse build date: " + e.getMessage());
        }
    }

    static String getVersion() {
        return _version;
    }
    
    static String getBuildTime() {
        DateFormat df = new SimpleDateFormat("HH:mm zz MMM d, yyyy"); 
        return df.format(_build.getTime());
    }
}    
