/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * $Id: acconfig.h,v 1.1 2003/04/14 12:26:02 sinisa Exp $
 */

#ifndef __ACCONFIG_H__
#define __ACCONFIG_H__ 1
#ifdef __cplusplus
extern "C" {
#endif

/*
 * Don't bring in xmlmemory.h defines.  Use our own in all cases.
 * _DEBUG_MEMORY_ALLOC_ define prevents inclusion of contents of xmlmemory.h
 * This allows us to use a completely unmodified libxml source tree.
 * We don't want to be in the business of maintaing a parallel version
 * of libxml when the current version works just fine.
 */
#define xmlFree(x) edir_free((x))
#define xmlMalloc(x) ((void *) edir_malloc(x))
#define xmlRealloc(p, x) ((void *) edir_realloc((p), (x)))
#define xmlMemStrdup(x) ((char *) edir_strdup((x)))
#define xmlInitMemory()
#define xmlMemUsed()
#define xmlInitMemory()
#define xmlMemoryDump()
#define xmlMemDisplay(x)
#define xmlMemShow(x, d)
#define _DEBUG_MEMORY_ALLOC_

@TOP@
@BOTTOM@
/* Define if the system include files do not declare "union semun" */
#undef EDIR_NEED_UNION_SEMUN

/* Define if we know where the default scoreboard data file is */
#undef EDIR_AC_DEF_SB_DATA_FILE

/* Define if we know where the default scoreboard lock file is */
#undef EDIR_AC_DEF_SB_LOCK_FILE

/* Define if we know where the default daemon file is */
#undef EDIR_AC_DAEMON_DIR

/* Define if we know where the default daemon file is */
#undef EDIR_AC_CONFIG_DIR

/* libxml additions */
#undef PACKAGE
#undef VERSION
#undef HAVE_LIBZ
#undef HAVE_LIBM
#undef HAVE_ISINF
#undef HAVE_ISNAN
#undef HAVE_FPCLASS
#undef HAVE_FP_CLASS
#undef HAVE_FP_CLASS_D
#undef HAVE_LIBHISTORY
#undef HAVE_LIBREADLINE

/* Primitive types */
#undef EDIR_TYPEOF_INT32
#undef EDIR_TYPEOF_UINT32
#undef EDIR_TYPEOF_INT16
#undef EDIR_TYPEOF_UINT16

/* Printf format for pointers */
#undef EDIR_PTR

#ifdef __cplusplus
} /* extern "C" */
#endif
#endif /* __ACCONFIG_H__ */

