#
# Enhydra Java Application Server 
# The Initial Developer of the Original Code is Lutris Technologies Inc. 
# Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
# Inc. 
# All Rights Reserved. 
#
# The contents of this file are subject to the Enhydra Public License Version
# 1.0 (the "License"); you may not use this file except in compliance with the
# License. You may obtain a copy of the License at
# http://www.enhydra.org/software/license/epl.html 
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations under the
# License. 
#
# $Id: acinclude.m4,v 1.1 2003/04/14 12:26:02 sinisa Exp $
#

AC_DEFUN(EDIR_CHECK_NSAPI, [
    AC_PATH_PROG(TEST,test,$PATH)dnl
    AC_MSG_CHECKING(for netscape plugins directory)
    AC_ARG_WITH(netscape-plugins-dir,
    [  --with-netscape-plugins-dir=PLUGINS-DIR tells configure where to look for
			                       the Netscape Plugins directory],
    [
	# we test for it actually being valid below...
	NETSCAPE_PLUGINS_DIR=${withval}
    ],
    [
	dnl Too bad, will have to guess the location
	
	for NPD_GUESS in \
	    /home/netscape/server4 \
	    /usr/local/netscape/server4 \
	    /local/netscape/server4
	do
	    if ${TEST} -x "${NPD_GUESS}/plugins" ; then
		NETSCAPE_PLUGINS_DIR=${NPD_GUESS}/plugins
		break
	    fi
	done
    ])    

    netscape_installed=true

    if ${TEST} -n "${NETSCAPE_PLUGINS_DIR}" ; then

	dnl Seems that we have it, but have to check if it is OK first
	
	if ${TEST} ! -d "${NETSCAPE_PLUGINS_DIR}" ; then
	    AC_MSG_ERROR(Invalid location for netscape-plugins-dir: '${NETSCAPE_PLUGINS_DIR}')
	    netscape_installed=false
	fi
    else
	netscape_installed=false
    fi

    if ${TEST} "${netscape_installed}" = "false" ; then
	AC_MSG_RESULT(could not find netscape plugins directory)
	AC_MSG_ERROR(You must specify a valid --with-netscape-plugins-dir=path)
    else
	AC_MSG_RESULT([${NETSCAPE_PLUGINS_DIR}, assume Apache 1.3 with DSO support])
    fi

    # VT: At this point, I'm perfectly sure that I have
    # ${NETSCAPE_PLUGINS_DIR} properly set, or not, so I
    # can forget about trying to figure out where it is

    AC_MSG_CHECKING(for NSAPI include directory)
    NSAPI_INCLUDE=${NETSCAPE_PLUGINS_DIR}/include
    AC_MSG_RESULT(${NSAPI_include})

    AC_MSG_CHECKING(for NSAPI library directory)
    NSAPI_LIB=${NETSCAPE_PLUGINS_DIR}/lib
    AC_MSG_RESULT(${NSAPI_LIB})

    libdir=/tmp/edir_lib

    AC_MSG_CHECKING(for NSAPI directory viability)
    for testdir in ${NSAPI_INCLUDE} ${NSAPI_LIB} ; do
	if ${TEST} ! -d ${testdir} ; then
	    AC_MSG_ERROR(${testdir} doesn't exist or is not a directory)
	fi
	if ${TEST} ! -r ${testdir} ; then
	    AC_MSG_ERROR(${testdir} is not readable)
	fi
    done
    AC_MSG_CHECKING(ok)

    # Now, I'm safe, all the directories exist

    # preprocessor option for include
    NSAPI_INCLUDE="-I${NSAPI_INCLUDE}"

    LIBDIR=`eval echo "${libdir}"`
    #DEF_DATA='"'`eval echo "${apache_dir}/logs/enhydra_director.data"`'"'
    #DEF_LOCK='"'`eval echo "${apache_dir}/logs/enhydra_director.ipc"`'"'
    #DEF_DAEMON='"'`eval echo "${sbindir}"`'"'
    #DEF_CONF='"'`eval echo "${sysconfdir}"`'"'

    #AC_DEFINE_UNQUOTED(EDIR_AC_DEF_SB_DATA_FILE, ${DEF_DATA})
    #AC_DEFINE_UNQUOTED(EDIR_AC_DEF_SB_LOCK_FILE, ${DEF_LOCK})
    #AC_DEFINE_UNQUOTED(EDIR_AC_DAEMON_DIR, ${DEF_DAEMON})
    #AC_DEFINE_UNQUOTED(EDIR_AC_CONFIG_DIR, ${DEF_CONF})

    AC_SUBST(NSAPI_INCLUDE)
    AC_SUBST(NSAPI_LIB)
])
