/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * $Id: edir_nsapi_memory_standard.c,v 1.1 2003/04/14 12:26:02 sinisa Exp $
 */

#ifdef XP_WIN32
#define NSAPI_PUBLIC __declspec(dllexport)
#include <winsock2.h>
#else /* !XP_WIN32 */
#define NSAPI_PUBLIC
#endif /* !XP_WIN32 */

#include "nsapi.h"
#include "edir.h"
#include "netsite.h"

extern void *
edir_realloc(void *vPtr, int32 sz)
{
    return REALLOC(vPtr, (int) sz);
}

extern void *
edir_malloc(int32 sz)
{
    return MALLOC((int) sz);
}

extern void
edir_free(void *p)
{
    /* Supposedly netscape will trash memory allocated in a request
     * after the request is finished, and if made outside a request
     * then the memory is permenant, so this function might never have to be
     * called, unless, of course, we need to allocate permenant memory durring
     * a request, in which case we'll need to use the always-perminant memory
     * allocation routines PERM_MALLOC and PERM_FREE.
     */
    /* FREE(p); */
}

