/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * $Id: kvtest.c,v 1.1 2003/04/14 12:26:02 sinisa Exp $
 */

#include "edir.h"
#include "edir_kvtable.h"

main()
{
    char		*cp, **cpp, *key;
    int32		i, n;
    edir_kvtable_t	*table;


    /* I just hand edit this for what I want to test - XXX FIX should be automated */
    table = edir_kvtable_create(EDIR_KVTABLE_TO_UPPER_PRESERVE);

    edir_kvtable_add(table, "Foo", "Bar");
    printf("Added '%s'='%s'\n", "Foo", "Bar"); 

    edir_kvtable_add(table, "Test1", "TVal1");
    printf("Added '%s'='%s'\n", "Test1", "TVal1"); 

    cp = edir_kvtable_find(table, "Foo");
    printf("Find(Foo) = '%s'\n", cp ? cp : "(null)");

    cp = edir_kvtable_find(table, "foo");
    printf("Find(foo) = '%s'\n", cp ? cp : "(null)");

    cp = edir_kvtable_find(table, "fOo");
    printf("Find(FOo) = '%s'\n", cp ? cp : "(null)");

    cp = edir_kvtable_find(table, "XXX");
    printf("Find(XXX) = '%s'\n", cp ? cp : "(null)");

    edir_kvtable_add(table, "Foo", "Zoo");

    cpp = edir_kvtable_first(table, &key, &n);
    while (cpp != NULL) {
	for (i=0; i<n; i++) printf("%s[%d]='%s'\n", key, i, cpp[i]);
	printf("%s = {", key);
	for (; *cpp; cpp++) printf(" %s ", *cpp);
	printf("}\n");
	cpp = edir_kvtable_next(table, &key, &n);
    }

    edir_kvtable_remove(table, "Foo");

    cp = edir_kvtable_find(table, "Foo");
    printf("Find(Foo) = '%s'\n", cp ? cp : "(null)");

    edir_kvtable_destroy(table);
    printf("Table destroyed\n");

}
