/*
 * Enhydra Java Application Server 
 * The Initial Developer of the Original Code is Lutris Technologies Inc. 
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc. 
 * All Rights Reserved. 
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html 
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License. 
 *
 * $Id: excl.c,v 1.1 2003/04/14 12:26:02 sinisa Exp $
 */

#include "edir.h"

main()
{
    static char *funcName = "main";
    char buf[1024];
    edir_exception_t *_exc = NULL, **exc = &_exc;
    edir_ipc_handle_t *mutex;
    int num=0;
    
    mutex = edir_mutex_obtain(NULL, &num, exc);
    if (*exc) EDIR_THROW(*exc);

    printf("Have mutex... Press <Enter> to request exclusive lock.\n");
    printf("Waiting for <Enter>: ");
    fflush(stdout);
    gets(buf);

    edir_mutex_lock_exclusive(mutex, 0, exc);
    if (*exc) EDIR_THROW(*exc);

    printf("Mutex locked exclusive... Press <Enter> to unlock and exit.\n");
    printf("Waiting for <Enter>: ");
    fflush(stdout);
    gets(buf);

    edir_mutex_unlock(mutex, 0, exc);
    if (*exc) EDIR_THROW(*exc);

    edir_mutex_release(mutex, exc);
    if (*exc) EDIR_THROW(*exc);

    printf("Mutex released.\n");

    exit(0);

except:
    if (*exc) {
	char *trace;
	trace = edir_exception_stack_trace(*exc);
	fprintf(stderr, "%s\n", trace);
	edir_free(trace);
	edir_exception_free(exc);
    }
    exit(1);
}
